import { QueryObject } from 'json2mq';
export declare type MediaQueryToMatch = string;
export declare type MediaQueryMatcherHandlerParams = {
    readonly matches: boolean;
    readonly mediaQuery: MediaQueryToMatch;
    readonly alias: string;
};
export declare type MediaQueryMatcherHandler = (matchedMq: MediaQueryMatcherHandlerParams) => void;
export declare type MediaQueryMatchListener = {
    readonly handlers: MediaQueryMatcherHandler[];
    readonly matcher: MediaQueryList;
    readonly listener: (e: MediaQueryListEvent | {
        matches: boolean;
    }) => void;
};
export declare type MediaQueryObject = string | number | [number, number?] | MediaQueryToMatch | QueryObject;
export declare type MediaQueryObjectWithShortcuts = MediaQueryObject | number | [number, number?];
export declare type MediaQueryAliases = {
    [alias: string]: MediaQueryToMatch;
};
export declare type MediaQueryMatchers = {
    [alias: string]: MediaQueryMatchListener;
};
export declare type MatchingAliases = {
    [alias: string]: boolean;
};
export declare type Mq = {
    aliases: MediaQueryAliases;
    matchers: MediaQueryMatchers;
    matchingAliases: MatchingAliases;
};
export declare type FineMediaQueries = {
    mq: Mq;
    setMatchingAliases: (matchingAliases: MatchingAliases) => void;
    on: (aliasOrMediaQuery: string, callback: MediaQueryMatcherHandler) => void;
    off: (aliasOrMediaQuery?: string, callback?: MediaQueryMatcherHandler) => void;
    addAlias: (alias: string | {
        [key: string]: MediaQueryToMatch | QueryObject;
    }, mediaQuery?: MediaQueryToMatch | QueryObject) => void;
    removeAlias: (alias: string) => void;
};
